var questionResults = [];

function choiceCheck(queNo) {
  var total = 0;
  var multi = false;
  var allCorrect = true;
  for ( var i = 0; i < allAnswers[queNo - 1].length; i++ ) {
  	 var answers = allAnswers[queNo - 1][i];
     if ( answers[0] > 0 && answers[0] < 100 )
        multi = true;
  	 var suffix = '_' + queNo + '_' + (i + 1);
     var choice = document.getElementById('answer' + suffix);
     if ( choice == null ) 
     	continue;
     var correct = (choice.checked && answers[0] > 0) || (!choice.checked && answers[0] <= 0);
     // totals
     if ( choice.checked && correct )
        total += answers[0];
     allCorrect = allCorrect && correct;
     // feedback
     if ( choice.checked )
     	setFeedbackPanel(suffix, correct ? 100 : 0, answers[2]);
     else
        clearFeedbackPanel(suffix);
  }
  if ( multi ) { // give some more feedback
     total = Math.round(total);
     if ( total == 0 ) { 
        setFeedbackPanel('_general_' + queNo, 0, 'Grozno... niti enega pravilnega odgovora nisi zadel.');
        questionResults[queNo] = 0;
     }
     else if ( !allCorrect ) {
        if ( total >= 100 )
           setFeedbackPanel('_general_' + queNo, 50, 'Odgovor je samo delno pravilen. Označil si ' + total + '% pravilnih odgovorov, vendar so med njimi tudi napačni.');
        else
           setFeedbackPanel('_general_' + queNo, 50, 'Odgovor je samo delno pravilen. Označil si ' + total + '% pravilnih odgovorov');
        questionResults[queNo] = 0.5;
     }
     else {
        setFeedbackPanel('_general_' + queNo, 100, 'Odgovor je popolnoma pravilen.');
        questionResults[queNo] = 1;
     }
  }
  else {
     questionResults[queNo] = allCorrect ? 1 : 0;
  }
}

function shortAnswerCheck(queNo) {
  var input = document.getElementById('answer_' + queNo).value;
  var answers = allAnswers[queNo - 1];
  for ( var i = 0; i < answers.length; i++ ) {
     if ( answers[i][1] == input || answers[i][1] == '*' ) {
        setFeedbackPanel('_' + queNo, answers[i][0], answers[i][2]);
        questionResults[queNo] = answers[i][0] / 100.0;
        return;
     }
  }
  setFeedbackPanel('_' + queNo, 0, 'Odgovor je napačen.');
  questionResults[queNo] = 0;
}

function matchingCheck(queNo) {
  var nCorrect = 0, nTotal = 0;
  for ( var sqNo = 1; ; sqNo++ ) {
     var suffix = '_' + queNo + '_' + sqNo;
     var inputElement = document.getElementById('answer' + suffix);
     if ( inputElement == null  ) break;
     var input = inputElement.value; 
     // check match
     var answer = allAnswers[queNo - 1][sqNo - 1];
     var correct = answer == input;
     setFeedbackPanel(suffix, correct ? 100 : 0, '');
     // update points
     nCorrect += correct ? 1 : 0;
     nTotal += 1;
  }
  questionResults[queNo] = nTotal > 0 ? nCorrect / nTotal : 1;
}

function clozeCheck(queNo) {
  var percCorrect = 0, percTotal = 0;
  for ( var sqNo = 1; ; sqNo++ ) {
     var suffix = '_' + queNo + '_' + sqNo;
     var inputElement = document.getElementById('answer' + suffix);
     if ( inputElement == null ) break;
     var input = inputElement.value;
     var answers = allAnswers[queNo - 1][sqNo - 1];
     // check match
     var percent = 0;
     var feedback = '';
     for ( var i in answers ) {
        if ( answers[i][1] == input || answers[i][1] == '*' ) {
           percent = answers[i][0];
           feedback = answers[i][2];
           break;
        }
     }
     setFeedbackPanel(suffix, percent, feedback);
     // update points
     percCorrect += percent;
     percTotal += 100;
  }
  questionResults[queNo] = percTotal > 0 ? percCorrect / percTotal : 1;
}

function compareNumericAnswers(val, input, tolerance, tolType) {
   if ( tolType == 1 )
      return Math.abs(val - input) <= tolerance * Math.abs(val);
   else if ( tolType == 2 )
      return Math.abs(val - input) <= tolerance;
   else if ( tolType == 3 ) {
      var low = val / (1 + tolerance);
      var high = val * (1 + tolerance);
      return (low <= val && val <= high) || (high <= val && val <= low);
   }
   alert("Unknown tolerance type!")
}

function calculatedCheck(queNo) {
  var suffix = '_' + queNo;
  var inputElement = document.getElementById('answer' + suffix);
  if ( inputElement == null ) return;
  // check value
  if ( inputElement.value.match(/\d+/) ) {
     var input = Number(inputElement.value.replace(/,/g, '.'));
     for ( var i in allAnswers[queNo - 1] ) {
        var answers = allAnswers[queNo - 1][i];
        var val = answers[2];
        var tolerance = answers[1];
        if ( val == '*' || compareNumericAnswers(val, input, tolerance, answers[4]) ) {
           setFeedbackPanel(suffix, answers[0], answers[3]);
           questionResults[queNo] = answers[0] / 100.0;
           return;
        }  
     }
  }
  setFeedbackPanel(suffix, 0, 'Odgovor ni pravilen');
  questionResults[queNo] = 0;
}

function setFeedbackPanel(suffix, percent, feedback) {
  // set images and feedback
  var buildh = '';
  if ( percent == 100 )
     buildh = '&nbsp;<img src="tick_green_big.gif"/>';
  else
     buildh = '&nbsp;<img src="cross_red_big.gif"/>';
  if ( feedback != '' )
     buildh = buildh + '&nbsp;<i style="background: yellow">(' + feedback + ')</i>';
  // put that in the html
  var feedbackElt = document.getElementById('feedback' + suffix);
  if ( feedbackElt != null ) {
     feedbackElt.innerHTML = buildh;
     // update math
     if ( typeof(jsMath) != 'undefined' && jsMath != null ) {
        jsMath.ConvertTeX(feedbackElt);
        jsMath.ProcessBeforeShowing(feedbackElt);
     }
  }
} 

function clearFeedbackPanel(suffix) {
  var feedbackElt = document.getElementById('feedback' + suffix);
  if ( feedbackElt != null )
     feedbackElt.innerHTML = "";
}

function trace(arg) {
   if ( window.console && window.console.firebug )
      console.info(arg);
}

function traceAll(arg) {
   if ( window.console && window.console.firebug ) {
      for ( key in arg )
         trace(key, ' -> ', arg[key]);
   }
}

function checkAnswers(queType, queNo) {
   if ( queType == 'shortanswer' )
      shortAnswerCheck(queNo)
   else if ( queType == 'matching' )
      matchingCheck(queNo)
   else if ( queType == 'cloze' )
      clozeCheck(queNo)
   else if ( queType == 'calculated' || queType == 'numerical' )
      calculatedCheck(queNo)
   else
      choiceCheck(queNo);
      
   sendPointsToLMS();
}

function replaceOneVariable(ttt, vname) {
  return eval(vname);
}

function replaceCalculated() {
  element = document.getElementById("quizBodyElement");
  element.innerHTML = element.innerHTML.replace(/!@@@([a-zA-Z0-9_]*)@@@!/g, replaceOneVariable); 
}

function tryEval(expr) {
  try {
    return eval(expr);
  } catch ( err ) {
    alert(err + '\n' + expr);
    return null;
  }
}

function handleEnter(event, queType, queNo) {
   if ( event.keyCode == 13 ) {
      checkAnswers(queType, queNo);
      return false;
   }
   return true;
}

// Base64 code from Tyler Akins -- http://rumkin.com (modified by Ico)
function makeDecodeMap(keyStr) {
   var decodeMap = {};
   for ( var k = 0; k < keyStr.length; k++ )
      decodeMap[keyStr.charAt(k)] = k;
   return decodeMap;
}

var base64DecodeMap = makeDecodeMap("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=");

function decode64Ascii(input) {
   // Remove all characters that are not A-Z, a-z, 0-9, +, /, or =
   input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

   var outputArr = new Array();
   var out = 0;
   
   for ( var i = 0; i < input.length; i += 4 ) {
      var enc1 = base64DecodeMap[input.charAt(i)];
      var enc2 = base64DecodeMap[input.charAt(i + 1)];
      var enc3 = base64DecodeMap[input.charAt(i + 2)];
      var enc4 = base64DecodeMap[input.charAt(i + 3)];

      var chr1 = (enc1 << 2) | (enc2 >> 4);
      var chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
      var chr3 = ((enc3 & 3) << 6) | enc4;

      outputArr[out++] = String.fromCharCode(chr1);
      if (enc3 != 64)
         outputArr[out++] = String.fromCharCode(chr2);
      if (enc4 != 64)
         outputArr[out++] = String.fromCharCode(chr3);
   }
   return outputArr.join('');
}

function utf8Decode(utftext) {
   var outArray = [];
   var i = 0, out = 0;
   var c = c1 = c2 = 0;

   while ( i < utftext.length ) {
      c = utftext.charCodeAt(i++);

      if (c < 128) {
         outArray[out++] = String.fromCharCode(c);
      }
      else if((c > 191) && (c < 224)) {
         c2 = utftext.charCodeAt(i++);
         outArray[out++] = String.fromCharCode(((c & 31) << 6) | (c2 & 63));
      }
      else {
         c2 = utftext.charCodeAt(i++);
         c3 = utftext.charCodeAt(i++);
         outArray[out++] = String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
      }
   }
   return outArray.join('');
}


if ( window.atob != null )
   decode64 = function (input) { return utf8Decode(window.atob(input)); }
else
   decode64 = function (input) { return utf8Decode(decode64Array(input)); }

function unscrambleCode(input) {
   var arr = decode64Ascii(input);
   var dest = [];
   for ( var i = 0; i < arr.length; i++ )
      dest[i] = String.fromCharCode((arr.charCodeAt(i) - i) & 255);
   var text = utf8Decode(dest.join(''));
   eval(text);
}

function sendPointsToLMS() {
   if ( typeof(haveScormSupport) != 'undefined' && haveScormSupport ) {
      var totalScore = 0;
      for ( var i in questionResults )
         totalScore += questionResults[i];
      // normalized score
      var score = 100 * (allAnswers.length > 0 ? totalScore / allAnswers.length : 1);
      doLMSSetValue("cmi.core.score.min", "0");  
      doLMSSetValue("cmi.core.score.max", "100");  
      doLMSSetValue("cmi.core.score.raw", "" + score);
      // set lesson status
      var mode = doLMSGetValue("cmi.core.lesson_mode");
      if ( mode != "review" && mode != "browse" ) {
         if ( score < 50 )
            doLMSSetValue( "cmi.core.lesson_status", "failed" );
         else 
            doLMSSetValue( "cmi.core.lesson_status", "passed" );
         //doLMSSetValue("cmi.core.exit", "");
      }
      // this has some misterious bugs - keeps reloading after commit
      // TODO: find out what the problem is 
      // doLMSCommit();
   }
}